From 55d339a1a9263f95d20f6683d1edb200130f06fc Mon Sep 17 00:00:00 2001
From: Michael Neumann <mneumann@ntecs.de>
Date: Sat, 9 Dec 2023 02:46:00 +0100
Subject: [PATCH] busdma - Remove filter functionality

- Remove filtfunc and filtarg arguments from bus_dma_tag_create() and
  fix all callers. All callers use NULL today for both filterfunc and
  filterarg with one exception: if_jme.

- Remove filter functionality internally and parent tag tracking.
  Without filter functions, we do not need to keep track of tag
  ancestry.  All inheritance of the parent tag's parameters occurs when
  creating the new child tag.

- rename run_filter() to addr_needs_bounce().

- FreeBSD keeps the filtfunc and filtarg arguments but requires them to
  be NULL.

- Drop filterfunc usage from if_jme. It should use 32bit DMA addressing,
  in which case no filterfunc is required. There seems to be a hardware
  "bug" in one specific chip revision concerning DMA transfers that
  cross the 4 GB boundary... if we stay within 32bits there should be no
  problem. A better fix would be to check the chip revision and only
  apply the limitations when we really have to.

  TODO: This needs some more careful review. Anyone using if_jme?

Mainly obtained from: FreeBSD (commits 7cb028de, 900907f4, 1228b93b, 3933ff56)
---
 share/man/man9/bus_dma.9                      | 52 ++------------
 sys/bus/firewire/fwdma.c                      |  6 +-
 sys/bus/firewire/fwohci.c                     |  2 +
 sys/bus/firewire/fwohci_pci.c                 |  2 +
 sys/bus/u4b/usb_busdma.c                      |  2 -
 sys/dev/crypto/hifn/hifn7751.c                |  1 -
 sys/dev/crypto/safe/safe.c                    |  3 -
 sys/dev/crypto/ubsec/ubsec.c                  |  2 -
 sys/dev/disk/advansys/adv_pci.c               |  2 -
 sys/dev/disk/advansys/advansys.c              |  2 -
 sys/dev/disk/advansys/adw_pci.c               |  1 -
 sys/dev/disk/advansys/adwcam.c                |  4 --
 sys/dev/disk/ahci/ahci_attach.c               |  8 ---
 sys/dev/disk/amd/amd.c                        |  1 -
 sys/dev/disk/buslogic/bt.c                    |  8 ---
 sys/dev/disk/buslogic/bt_pci.c                |  2 -
 sys/dev/disk/isp/isp_freebsd.h                |  8 ++-
 sys/dev/disk/mpt/mpt.h                        |  2 +-
 sys/dev/disk/nata/ata-dma.c                   |  8 +--
 sys/dev/disk/nvme/nvme_attach.c               |  8 ---
 sys/dev/disk/sbp/sbp.c                        |  2 +
 sys/dev/disk/sdhci/sdhci.c                    |  2 +-
 sys/dev/disk/sili/sili_attach.c               |  4 --
 sys/dev/disk/sym/sym_hipd.c                   |  3 +-
 sys/dev/disk/trm/trm.c                        |  7 --
 sys/dev/misc/dcons/dcons_crom.c               |  1 -
 sys/dev/netif/ae/if_ae.c                      |  1 -
 sys/dev/netif/age/if_age.c                    |  9 ---
 sys/dev/netif/alc/if_alc.c                    |  9 ---
 sys/dev/netif/ale/if_ale.c                    |  7 --
 sys/dev/netif/ath/ath/if_ath_ahb.c            |  3 +
 sys/dev/netif/ath/ath/if_ath_descdma.c        |  3 +
 sys/dev/netif/ath/ath/if_ath_pci.c            |  3 +
 sys/dev/netif/bce/if_bce.c                    | 10 ++-
 sys/dev/netif/bfe/if_bfe.c                    |  3 -
 sys/dev/netif/bge/if_bge.c                    |  4 +-
 sys/dev/netif/bnx/if_bnx.c                    |  6 +-
 sys/dev/netif/bwn/bwn/if_bwn.c                | 10 +++
 sys/dev/netif/de/if_de.c                      |  6 +-
 sys/dev/netif/em/if_em.c                      |  3 -
 sys/dev/netif/emx/if_emx.c                    |  3 -
 sys/dev/netif/et/if_et.c                      |  3 -
 sys/dev/netif/igb/if_igb.c                    |  4 +-
 sys/dev/netif/iwi/if_iwi.c                    | 10 +--
 sys/dev/netif/iwm/if_iwm.c                    |  2 -
 sys/dev/netif/iwn/if_iwn.c                    |  6 +-
 sys/dev/netif/ix/if_ix.c                      |  4 +-
 sys/dev/netif/jme/if_jme.c                    | 26 +++++--
 sys/dev/netif/lnc/if_lnc_pci.c                |  2 -
 sys/dev/netif/msk/if_msk.c                    |  6 --
 sys/dev/netif/mxge/if_mxge.c                  |  4 --
 sys/dev/netif/nfe/if_nfe.c                    |  3 -
 sys/dev/netif/oce/oce_queue.c                 |  2 -
 sys/dev/netif/oce/oce_util.c                  |  2 -
 sys/dev/netif/ral/rt2560.c                    |  8 +--
 sys/dev/netif/ral/rt2661.c                    |  8 +--
 sys/dev/netif/ral/rt2860.c                    |  8 +--
 sys/dev/netif/re/if_re.c                      |  3 -
 sys/dev/netif/re/re.c                         |  2 +-
 sys/dev/netif/rl/if_rl.c                      |  2 -
 sys/dev/netif/sis/if_sis.c                    |  3 -
 sys/dev/netif/sk/if_sk.c                      |  5 --
 sys/dev/netif/stge/if_stge.c                  |  3 -
 sys/dev/netif/vge/if_vge.c                    |  4 --
 sys/dev/netif/wpi/if_wpi.c                    |  6 +-
 sys/dev/netif/xl/if_xl.c                      |  3 -
 sys/dev/raid/aac/aac.c                        |  3 -
 sys/dev/raid/aac/aac_pci.c                    |  1 -
 sys/dev/raid/amr/amr_pci.c                    |  6 --
 sys/dev/raid/arcmsr/arcmsr.c                  |  6 --
 sys/dev/raid/asr/asr.c                        |  2 -
 sys/dev/raid/ciss/ciss.c                      |  4 --
 sys/dev/raid/dpt/dpt_pci.c                    |  2 -
 sys/dev/raid/dpt/dpt_scsi.c                   |  3 -
 sys/dev/raid/hpt27xx/hpt27xx_osm_bsd.c        |  1 -
 sys/dev/raid/hptiop/hptiop.c                  |  5 --
 sys/dev/raid/hptmv/entry.c                    |  1 -
 sys/dev/raid/hptrr/hptrr_osm_bsd.c            |  1 -
 sys/dev/raid/ida/ida.c                        |  2 -
 sys/dev/raid/ida/ida_pci.c                    |  2 +-
 sys/dev/raid/iir/iir.c                        |  3 -
 sys/dev/raid/iir/iir_pci.c                    |  1 -
 sys/dev/raid/ips/ips.c                        |  6 --
 sys/dev/raid/ips/ips_commands.c               |  6 --
 sys/dev/raid/ips/ips_ioctl.c                  |  2 -
 sys/dev/raid/ips/ips_pci.c                    |  2 -
 sys/dev/raid/mfi/mfi.c                        |  9 ---
 sys/dev/raid/mfi/mfi_pci.c                    |  1 -
 sys/dev/raid/mlx/mlx.c                        |  2 -
 sys/dev/raid/mlx/mlx_pci.c                    |  1 -
 sys/dev/raid/mly/mly.c                        |  5 --
 sys/dev/raid/mpr/mpr.c                        |  7 --
 sys/dev/raid/mpr/mpr_pci.c                    |  1 -
 sys/dev/raid/mpr/mpr_user.c                   |  1 -
 sys/dev/raid/mps/mps.c                        |  6 --
 sys/dev/raid/mps/mps_pci.c                    |  1 -
 sys/dev/raid/mps/mps_user.c                   |  1 -
 sys/dev/raid/mrsas/mrsas.c                    | 13 ----
 sys/dev/raid/mrsas/mrsas_ioctl.c              |  3 -
 sys/dev/raid/twa/tw_osl_freebsd.c             |  4 --
 sys/dev/raid/twe/twe_freebsd.c                |  4 --
 sys/dev/raid/tws/tws.c                        |  3 -
 sys/dev/sound/pci/als4000.c                   |  1 -
 sys/dev/sound/pci/atiixp.c                    |  2 -
 sys/dev/sound/pci/aureal.c                    |  1 -
 sys/dev/sound/pci/cmi.c                       |  1 -
 sys/dev/sound/pci/cs4281.c                    |  1 -
 sys/dev/sound/pci/emu10k1.c                   |  1 -
 sys/dev/sound/pci/emu10kx.c                   |  1 -
 sys/dev/sound/pci/envy24.c                    |  1 -
 sys/dev/sound/pci/envy24ht.c                  |  1 -
 sys/dev/sound/pci/es137x.c                    |  1 -
 sys/dev/sound/pci/fm801.c                     |  1 -
 sys/dev/sound/pci/hda/hdac.c                  |  4 --
 sys/dev/sound/pci/hdspe.c                     |  2 -
 sys/dev/sound/pci/ich.c                       |  4 +-
 sys/dev/sound/pci/maestro.c                   |  2 -
 sys/dev/sound/pci/solo.c                      |  1 -
 sys/dev/sound/pci/t4dwave.c                   |  1 -
 sys/dev/sound/pci/via8233.c                   |  2 -
 sys/dev/sound/pci/via82c686.c                 |  2 -
 sys/dev/sound/pci/vibes.c                     |  1 -
 sys/dev/video/cxm/cxm.c                       |  6 +-
 sys/dev/virtual/amazon/ena/ena.c              |  3 -
 sys/dev/virtual/vmware/pvscsi/pvscsi.c        |  6 +-
 sys/dev/virtual/vmware/vmxnet3/if_vmx.c       |  3 -
 sys/kern/subr_busdma.c                        |  2 +-
 sys/netproto/802_11/README.DRAGONFLY          |  1 -
 sys/platform/pc64/x86_64/busdma_machdep.c     | 72 +++++--------------
 .../vkernel64/platform/busdma_machdep.c       | 70 +++++-------------
 sys/sys/bus_dma.h                             | 14 +---
 131 files changed, 150 insertions(+), 531 deletions(-)

diff --git a/sys/bus/firewire/fwdma.c b/sys/bus/firewire/fwdma.c
index ba6460273d..e27419c334 100644
--- a/sys/bus/firewire/fwdma.c
+++ b/sys/bus/firewire/fwdma.c
@@ -74,7 +74,9 @@ fwdma_malloc(struct firewire_comm *fc, int alignment, bus_size_t size,
 		/*boundary*/ 0,
 		/*lowaddr*/ BUS_SPACE_MAXADDR_32BIT,
 		/*highaddr*/ BUS_SPACE_MAXADDR,
-		/*filter*/NULL, /*filterarg*/NULL,
+#if defined(__FreeBSD__)
+        /*filter*/NULL, /*filterarg*/NULL,
+#endif
 		/*maxsize*/ size,
 		/*nsegments*/ 1,
 		/*maxsegsz*/ BUS_SPACE_MAXSIZE_32BIT,
@@ -168,7 +170,9 @@ fwdma_malloc_multiseg(struct firewire_comm *fc, int alignment,
 			/*boundary*/ 0,
 			/*lowaddr*/ BUS_SPACE_MAXADDR_32BIT,
 			/*highaddr*/ BUS_SPACE_MAXADDR,
+#if defined(__FreeBSD__)
 			/*filter*/NULL, /*filterarg*/NULL,
+#endif
 			/*maxsize*/ ssize,
 			/*nsegments*/ 1,
 			/*maxsegsz*/ BUS_SPACE_MAXSIZE_32BIT,
diff --git a/sys/bus/firewire/fwohci.c b/sys/bus/firewire/fwohci.c
index 0eea9b2bc2..9e963968de 100644
--- a/sys/bus/firewire/fwohci.c
+++ b/sys/bus/firewire/fwohci.c
@@ -1196,7 +1196,9 @@ fwohci_db_init(struct fwohci_softc *sc, struct fwohci_dbch *dbch)
 			/*alignment*/ 1, /*boundary*/ 0,
 			/*lowaddr*/ BUS_SPACE_MAXADDR_32BIT,
 			/*highaddr*/ BUS_SPACE_MAXADDR,
+#if defined(__FreeBSD__)
 			/*filter*/NULL, /*filterarg*/NULL,
+#endif
 			/*maxsize*/ dbch->xferq.psize,
 			/*nsegments*/ dbch->ndesc > 3 ? dbch->ndesc - 2 : 1,
 			/*maxsegsz*/ MAX_REQCOUNT,
diff --git a/sys/bus/firewire/fwohci_pci.c b/sys/bus/firewire/fwohci_pci.c
index d896caf9b2..85b99b2cbd 100644
--- a/sys/bus/firewire/fwohci_pci.c
+++ b/sys/bus/firewire/fwohci_pci.c
@@ -305,7 +305,9 @@ fwohci_pci_attach(device_t self)
 				/*lowaddr*/BUS_SPACE_MAXADDR_32BIT,
 #endif
 				/*highaddr*/BUS_SPACE_MAXADDR,
+#if defined(__FreeBSD__)
 				/*filter*/NULL, /*filterarg*/NULL,
+#endif
 				/*maxsize*/0x100000,
 				/*nsegments*/0x20,
 				/*maxsegsz*/0x8000,
diff --git a/sys/bus/u4b/usb_busdma.c b/sys/bus/u4b/usb_busdma.c
index a89c4a00b0..124b4bfe13 100644
--- a/sys/bus/u4b/usb_busdma.c
+++ b/sys/bus/u4b/usb_busdma.c
@@ -360,8 +360,6 @@ usb_dma_tag_create(struct usb_dma_tag *udt,
 	     /* boundary  */ 0,
 	     /* lowaddr   */ (2ULL << (udt->tag_parent->dma_bits - 1)) - 1,
 	     /* highaddr  */ BUS_SPACE_MAXADDR,
-	     /* filter    */ NULL,
-	     /* filterarg */ NULL,
 	     /* maxsize   */ size,
 	     /* nsegments */ (align == 1 && size > 1) ? (2 + (size / USB_PAGE_SIZE)) : 1,
 	     /* maxsegsz  */ (align == 1 && size > USB_PAGE_SIZE) ? USB_PAGE_SIZE : size,
diff --git a/sys/dev/crypto/hifn/hifn7751.c b/sys/dev/crypto/hifn/hifn7751.c
index 7412aa0ff1..c7bb6f59ac 100644
--- a/sys/dev/crypto/hifn/hifn7751.c
+++ b/sys/dev/crypto/hifn/hifn7751.c
@@ -453,7 +453,6 @@ hifn_attach(device_t dev)
 			       1, 0,			/* alignment,boundary */
 			       BUS_SPACE_MAXADDR_32BIT,	/* lowaddr */
 			       BUS_SPACE_MAXADDR,	/* highaddr */
-			       NULL, NULL,		/* filter, filterarg */
 			       HIFN_MAX_DMALEN,		/* maxsize */
 			       MAX_SCATTER,		/* nsegments */
 			       HIFN_MAX_SEGLEN,		/* maxsegsize */
diff --git a/sys/dev/crypto/safe/safe.c b/sys/dev/crypto/safe/safe.c
index 160e921d36..e4db4d55ad 100644
--- a/sys/dev/crypto/safe/safe.c
+++ b/sys/dev/crypto/safe/safe.c
@@ -292,7 +292,6 @@ safe_attach(device_t dev)
 			       SAFE_DMA_BOUNDARY,	/* boundary */
 			       BUS_SPACE_MAXADDR_32BIT,	/* lowaddr */
 			       BUS_SPACE_MAXADDR,	/* highaddr */
-			       NULL, NULL,		/* filter, filterarg */
 			       SAFE_MAX_DMA,		/* maxsize */
 			       SAFE_MAX_PART,		/* nsegments */
 			       SAFE_MAX_SSIZE,		/* maxsegsize */
@@ -306,7 +305,6 @@ safe_attach(device_t dev)
 			       SAFE_MAX_DSIZE,		/* boundary */
 			       BUS_SPACE_MAXADDR_32BIT,	/* lowaddr */
 			       BUS_SPACE_MAXADDR,	/* highaddr */
-			       NULL, NULL,		/* filter, filterarg */
 			       SAFE_MAX_DMA,		/* maxsize */
 			       SAFE_MAX_PART,		/* nsegments */
 			       SAFE_MAX_DSIZE,		/* maxsegsize */
@@ -1803,7 +1801,6 @@ safe_dma_malloc(
 			       sizeof(u_int32_t), 0,	/* alignment, bounds */
 			       BUS_SPACE_MAXADDR_32BIT,	/* lowaddr */
 			       BUS_SPACE_MAXADDR,	/* highaddr */
-			       NULL, NULL,		/* filter, filterarg */
 			       size,			/* maxsize */
 			       1,			/* nsegments */
 			       size,			/* maxsegsize */
diff --git a/sys/dev/crypto/ubsec/ubsec.c b/sys/dev/crypto/ubsec/ubsec.c
index 0659c4064c..a4acf7a192 100644
--- a/sys/dev/crypto/ubsec/ubsec.c
+++ b/sys/dev/crypto/ubsec/ubsec.c
@@ -374,7 +374,6 @@ ubsec_attach(device_t dev)
 			       1, 0,			/* alignment, bounds */
 			       BUS_SPACE_MAXADDR_32BIT,	/* lowaddr */
 			       BUS_SPACE_MAXADDR,	/* highaddr */
-			       NULL, NULL,		/* filter, filterarg */
 			       0x3ffff,			/* maxsize */
 			       UBS_MAX_SCATTER,		/* nsegments */
 			       0xffff,			/* maxsegsize */
@@ -1847,7 +1846,6 @@ ubsec_dma_malloc(
 			       1, 0,			/* alignment, bounds */
 			       BUS_SPACE_MAXADDR_32BIT,	/* lowaddr */
 			       BUS_SPACE_MAXADDR,	/* highaddr */
-			       NULL, NULL,		/* filter, filterarg */
 			       size,			/* maxsize */
 			       1,			/* nsegments */
 			       size,			/* maxsegsize */
diff --git a/sys/dev/disk/advansys/adv_pci.c b/sys/dev/disk/advansys/adv_pci.c
index 015966fbdc..34f5d2a07a 100644
--- a/sys/dev/disk/advansys/adv_pci.c
+++ b/sys/dev/disk/advansys/adv_pci.c
@@ -185,7 +185,6 @@ adv_pci_attach(device_t dev)
 				   /*boundary*/0,
 				   /*lowaddr*/ADV_PCI_MAX_DMA_ADDR,
 				   /*highaddr*/BUS_SPACE_MAXADDR,
-				   /*filter*/NULL, /*filterarg*/NULL,
 				   /*maxsize*/BUS_SPACE_MAXSIZE_32BIT,
 				   /*nsegments*/BUS_SPACE_UNRESTRICTED,
 				   /*maxsegsz*/ADV_PCI_MAX_DMA_COUNT,
@@ -207,7 +206,6 @@ adv_pci_attach(device_t dev)
 		if (bus_dma_tag_create(adv->parent_dmat,
 				       /*alignment*/8, /*boundary*/0,
 				       ADV_PCI_MAX_DMA_ADDR, BUS_SPACE_MAXADDR,
-				       /*filter*/NULL, /*filterarg*/NULL,
 				       ADV_OVERRUN_BSIZE, /*nsegments*/1,
 				       BUS_SPACE_MAXSIZE_32BIT, /*flags*/0,
 				       &overrun_dmat) != 0) {
diff --git a/sys/dev/disk/advansys/advansys.c b/sys/dev/disk/advansys/advansys.c
index 6180b8db9c..762e6dd567 100644
--- a/sys/dev/disk/advansys/advansys.c
+++ b/sys/dev/disk/advansys/advansys.c
@@ -1329,7 +1329,6 @@ adv_attach(struct adv_softc *adv)
 	if (bus_dma_tag_create(adv->parent_dmat, /*alignment*/1, /*boundary*/0,
 			       /*lowaddr*/BUS_SPACE_MAXADDR,
 			       /*highaddr*/BUS_SPACE_MAXADDR,
-			       /*filter*/NULL, /*filterarg*/NULL,
 			       /*maxsize*/MAXPHYS,
 			       /*nsegments*/max_sg,
 			       /*maxsegsz*/BUS_SPACE_MAXSIZE_32BIT,
@@ -1343,7 +1342,6 @@ adv_attach(struct adv_softc *adv)
 	if (bus_dma_tag_create(adv->parent_dmat, /*alignment*/1, /*boundary*/0,
 			       /*lowaddr*/BUS_SPACE_MAXADDR,
 			       /*highaddr*/BUS_SPACE_MAXADDR,
-			       /*filter*/NULL, /*filterarg*/NULL,
 			       sizeof(struct scsi_sense_data)*adv->max_openings,
 			       /*nsegments*/1,
 			       /*maxsegsz*/BUS_SPACE_MAXSIZE_32BIT,
diff --git a/sys/dev/disk/advansys/adw_pci.c b/sys/dev/disk/advansys/adw_pci.c
index 3fa0f736b7..aa0cc4bceb 100644
--- a/sys/dev/disk/advansys/adw_pci.c
+++ b/sys/dev/disk/advansys/adw_pci.c
@@ -254,7 +254,6 @@ adw_pci_attach(device_t dev)
 				   /*boundary*/0,
 				   /*lowaddr*/ADW_PCI_MAX_DMA_ADDR,
 				   /*highaddr*/BUS_SPACE_MAXADDR,
-				   /*filter*/NULL, /*filterarg*/NULL,
 				   /*maxsize*/BUS_SPACE_MAXSIZE_32BIT,
 				   /*nsegments*/BUS_SPACE_UNRESTRICTED,
 				   /*maxsegsz*/ADW_PCI_MAX_DMA_COUNT,
diff --git a/sys/dev/disk/advansys/adwcam.c b/sys/dev/disk/advansys/adwcam.c
index 1debf2e278..5a15c11ffd 100644
--- a/sys/dev/disk/advansys/adwcam.c
+++ b/sys/dev/disk/advansys/adwcam.c
@@ -1025,7 +1025,6 @@ adw_init(struct adw_softc *adw)
 	if (bus_dma_tag_create(adw->parent_dmat, /*alignment*/1, /*boundary*/0,
 			       /*lowaddr*/BUS_SPACE_MAXADDR_32BIT,
 			       /*highaddr*/BUS_SPACE_MAXADDR,
-			       /*filter*/NULL, /*filterarg*/NULL,
 			       /*maxsize*/MAXBSIZE, /*nsegments*/ADW_SGSIZE,
 			       /*maxsegsz*/BUS_SPACE_MAXSIZE_32BIT,
 			       /*flags*/BUS_DMA_ALLOCNOW,
@@ -1040,7 +1039,6 @@ adw_init(struct adw_softc *adw)
 			       /*boundary*/0,
 			       /*lowaddr*/BUS_SPACE_MAXADDR_32BIT,
 			       /*highaddr*/BUS_SPACE_MAXADDR,
-			       /*filter*/NULL, /*filterarg*/NULL,
 			       (adw->max_acbs + ADW_NUM_CARRIER_QUEUES + 1)
 				* sizeof(struct adw_carrier),
 			       /*nsegments*/1,
@@ -1095,7 +1093,6 @@ adw_init(struct adw_softc *adw)
 	if (bus_dma_tag_create(adw->parent_dmat, /*alignment*/1, /*boundary*/0,
 			       /*lowaddr*/BUS_SPACE_MAXADDR,
 			       /*highaddr*/BUS_SPACE_MAXADDR,
-			       /*filter*/NULL, /*filterarg*/NULL,
 			       adw->max_acbs * sizeof(struct acb),
 			       /*nsegments*/1,
 			       /*maxsegsz*/BUS_SPACE_MAXSIZE_32BIT,
@@ -1125,7 +1122,6 @@ adw_init(struct adw_softc *adw)
 	if (bus_dma_tag_create(adw->parent_dmat, /*alignment*/1, /*boundary*/0,
 			       /*lowaddr*/BUS_SPACE_MAXADDR,
 			       /*highaddr*/BUS_SPACE_MAXADDR,
-			       /*filter*/NULL, /*filterarg*/NULL,
 			       PAGE_SIZE, /*nsegments*/1,
 			       /*maxsegsz*/BUS_SPACE_MAXSIZE_32BIT,
 			       /*flags*/0, &adw->sg_dmat) != 0) {
diff --git a/sys/dev/disk/ahci/ahci_attach.c b/sys/dev/disk/ahci/ahci_attach.c
index 21a8822072..df0d8e08bb 100644
--- a/sys/dev/disk/ahci/ahci_attach.c
+++ b/sys/dev/disk/ahci/ahci_attach.c
@@ -359,8 +359,6 @@ ahci_pci_attach(device_t dev)
 			PAGE_SIZE,			/* boundary */
 			addr,				/* loaddr? */
 			BUS_SPACE_MAXADDR,		/* hiaddr */
-			NULL,				/* filter */
-			NULL,				/* filterarg */
 			sc->sc_rfis_size,		/* [max]size */
 			1,				/* maxsegs */
 			sc->sc_rfis_size,		/* maxsegsz */
@@ -375,8 +373,6 @@ ahci_pci_attach(device_t dev)
 			4096 * 1024,			/* boundary */
 			addr,				/* loaddr? */
 			BUS_SPACE_MAXADDR,		/* hiaddr */
-			NULL,				/* filter */
-			NULL,				/* filterarg */
 			sc->sc_cmdlist_size,
 			1,				/* maxsegs */
 			sc->sc_cmdlist_size,
@@ -392,8 +388,6 @@ ahci_pci_attach(device_t dev)
 			4096 * 1024,			/* boundary */
 			addr,				/* loaddr? */
 			BUS_SPACE_MAXADDR,		/* hiaddr */
-			NULL,				/* filter */
-			NULL,				/* filterarg */
 			sc->sc_ncmds * sizeof(struct ahci_cmd_table),
 			1,				/* maxsegs */
 			sc->sc_ncmds * sizeof(struct ahci_cmd_table),
@@ -410,8 +404,6 @@ ahci_pci_attach(device_t dev)
 			0,				/* boundary */
 			addr,				/* loaddr? */
 			BUS_SPACE_MAXADDR,		/* hiaddr */
-			NULL,				/* filter */
-			NULL,				/* filterarg */
 			4096 * 1024,			/* maxiosize */
 			AHCI_MAX_PRDT,			/* maxsegs */
 			65536,				/* maxsegsz */
diff --git a/sys/dev/disk/amd/amd.c b/sys/dev/disk/amd/amd.c
index e2c8c89294..3a21ebd7e8 100644
--- a/sys/dev/disk/amd/amd.c
+++ b/sys/dev/disk/amd/amd.c
@@ -2294,7 +2294,6 @@ amd_init(device_t dev)
 			       /*boundary*/0,
 			       /*lowaddr*/BUS_SPACE_MAXADDR_32BIT,
 			       /*highaddr*/BUS_SPACE_MAXADDR,
-			       /*filter*/NULL, /*filterarg*/NULL,
 			       /*maxsize*/MAXBSIZE, /*nsegments*/AMD_NSEG,
 			       /*maxsegsz*/AMD_MAXTRANSFER_SIZE,
 			       /*flags*/BUS_DMA_ALLOCNOW,
diff --git a/sys/dev/disk/buslogic/bt.c b/sys/dev/disk/buslogic/bt.c
index d7d7b29624..f7859428b5 100644
--- a/sys/dev/disk/buslogic/bt.c
+++ b/sys/dev/disk/buslogic/bt.c
@@ -614,8 +614,6 @@ bt_init(device_t dev)
 				/* boundary	*/ 0,
 				/* lowaddr	*/ BUS_SPACE_MAXADDR,
 				/* highaddr	*/ BUS_SPACE_MAXADDR,
-				/* filter	*/ NULL,
-				/* filterarg	*/ NULL,
 				/* maxsize	*/ MAXBSIZE,
 				/* nsegments	*/ BT_NSEG,
 				/* maxsegsz	*/ BUS_SPACE_MAXSIZE_32BIT,
@@ -631,8 +629,6 @@ bt_init(device_t dev)
 				/* boundary	*/ 0,
 				/* lowaddr	*/ BUS_SPACE_MAXADDR,
 				/* highaddr	*/ BUS_SPACE_MAXADDR,
-				/* filter	*/ NULL,
-				/* filterarg	*/ NULL,
 				/* maxsize	*/ bt->num_boxes *
 						   (sizeof(bt_mbox_in_t) +
 						    sizeof(bt_mbox_out_t)),
@@ -674,8 +670,6 @@ bt_init(device_t dev)
 				/* boundary	*/ 0,
 				/* lowaddr	*/ BUS_SPACE_MAXADDR,
 				/* highaddr	*/ BUS_SPACE_MAXADDR,
-				/* filter	*/ NULL,
-				/* filterarg	*/ NULL,
 				/* maxsize	*/ bt->max_ccbs *
 						   sizeof(struct bt_ccb),
 				/* nsegments	*/ 1,
@@ -709,8 +703,6 @@ bt_init(device_t dev)
 				/* boundary	*/ 0,
 				/* lowaddr	*/ BUS_SPACE_MAXADDR,
 				/* highaddr	*/ BUS_SPACE_MAXADDR,
-				/* filter	*/ NULL,
-				/* filterarg	*/ NULL,
 				/* maxsize	*/ PAGE_SIZE,
 				/* nsegments	*/ 1,
 				/* maxsegsz	*/ BUS_SPACE_MAXSIZE_32BIT,
diff --git a/sys/dev/disk/buslogic/bt_pci.c b/sys/dev/disk/buslogic/bt_pci.c
index 7d78596efe..fa63788bbf 100644
--- a/sys/dev/disk/buslogic/bt_pci.c
+++ b/sys/dev/disk/buslogic/bt_pci.c
@@ -135,8 +135,6 @@ bt_pci_attach(device_t dev)
 				/* boundary	*/ 0,
 				/* lowaddr	*/ BUS_SPACE_MAXADDR_32BIT,
 				/* highaddr	*/ BUS_SPACE_MAXADDR,
-				/* filter	*/ NULL,
-				/* filterarg	*/ NULL,
 				/* maxsize	*/ BUS_SPACE_MAXSIZE_32BIT,
 				/* nsegments	*/ ~0,
 				/* maxsegsz	*/ BUS_SPACE_MAXSIZE_32BIT,
diff --git a/sys/dev/disk/isp/isp_freebsd.h b/sys/dev/disk/isp/isp_freebsd.h
index 83f1578d96..b7aea29424 100644
--- a/sys/dev/disk/isp/isp_freebsd.h
+++ b/sys/dev/disk/isp/isp_freebsd.h
@@ -644,8 +644,12 @@ void isp_common_dmateardown(ispsoftc_t *, struct ccb_scsiio *, uint32_t);
  * Platform Version specific defines
  */
 #define	BUS_DMA_ROOTARG(x)	bus_get_dma_tag(x)
-#define	isp_dma_tag_create(a, b, c, d, e, f, g, h, i, j, k, z)	\
-	bus_dma_tag_create(a, b, c, d, e, f, g, h, i, j, k, z)
+#define	isp_dma_tag_create(parent_tag, alignment, boundary, \
+			lowaddr, highaddr, _filter, _filterarg, \
+			maxsize, nsegments, maxsegsz, flags, dma_tagp)	\
+        bus_dma_tag_create(parent_tag, alignment, boundary, \
+			lowaddr, highaddr, maxsize, nsegments, maxsegsz, \
+			flags, dma_tagp)
 
 #define	isp_setup_intr	bus_setup_intr
 
diff --git a/sys/dev/disk/mpt/mpt.h b/sys/dev/disk/mpt/mpt.h
index fb9c31b3ed..6d15659447 100644
--- a/sys/dev/disk/mpt/mpt.h
+++ b/sys/dev/disk/mpt/mpt.h
@@ -214,7 +214,7 @@ int mpt_modevent(module_t, int, void *);
 			   maxsize, nsegments, maxsegsz, flags,		\
 			   dma_tagp)					\
 	bus_dma_tag_create(parent_tag, alignment, boundary,		\
-			   lowaddr, highaddr, filter, filterarg,	\
+			   lowaddr, highaddr, /*filter, filterarg,*/	\
 			   maxsize, nsegments, maxsegsz, flags,		\
 			   dma_tagp)
 
diff --git a/sys/dev/disk/nata/ata-dma.c b/sys/dev/disk/nata/ata-dma.c
index 47e63ba38f..8f34cb179d 100644
--- a/sys/dev/disk/nata/ata-dma.c
+++ b/sys/dev/disk/nata/ata-dma.c
@@ -95,20 +95,20 @@ ata_dmaalloc(device_t dev)
 
     if (bus_dma_tag_create(NULL, ch->dma->alignment, 0,
 			   ch->dma->max_address, BUS_SPACE_MAXADDR,
-			   NULL, NULL, ch->dma->max_iosize,
+			   ch->dma->max_iosize,
 			   ATA_DMA_ENTRIES, ch->dma->segsize,
 			   0, &ch->dma->dmatag))
 	goto error;
 
     if (bus_dma_tag_create(ch->dma->dmatag, PAGE_SIZE, PAGE_SIZE,
 			   ch->dma->max_address, BUS_SPACE_MAXADDR,
-			   NULL, NULL, MAXTABSZ, 1, MAXTABSZ,
+			   MAXTABSZ, 1, MAXTABSZ,
 			   0, &ch->dma->sg_tag))
 	goto error;
 
     if (bus_dma_tag_create(ch->dma->dmatag,ch->dma->alignment,ch->dma->boundary,
 			   ch->dma->max_address, BUS_SPACE_MAXADDR,
-			   NULL, NULL, ch->dma->max_iosize,
+			   ch->dma->max_iosize,
 			   ATA_DMA_ENTRIES, ch->dma->segsize,
 			   0, &ch->dma->data_tag))
 	goto error;
@@ -129,7 +129,7 @@ ata_dmaalloc(device_t dev)
 
     if (bus_dma_tag_create(ch->dma->dmatag, PAGE_SIZE, 64 * 1024,
 			   ch->dma->max_address, BUS_SPACE_MAXADDR,
-			   NULL, NULL, MAXWSPCSZ, 1, MAXWSPCSZ,
+			   MAXWSPCSZ, 1, MAXWSPCSZ,
 			   0, &ch->dma->work_tag))
 	goto error;
 
diff --git a/sys/dev/disk/nvme/nvme_attach.c b/sys/dev/disk/nvme/nvme_attach.c
index a6ffefd29b..3182d21e9f 100644
--- a/sys/dev/disk/nvme/nvme_attach.c
+++ b/sys/dev/disk/nvme/nvme_attach.c
@@ -347,8 +347,6 @@ nvme_pci_attach(device_t dev)
 			4 * 1024 * 1024,		/* boundary */
 			BUS_SPACE_MAXADDR,		/* loaddr? */
 			BUS_SPACE_MAXADDR,		/* hiaddr */
-			NULL,				/* filter */
-			NULL,				/* filterarg */
 			sc->prp_bytes,			/* [max]size */
 			1,				/* maxsegs */
 			sc->prp_bytes,			/* maxsegsz */
@@ -361,8 +359,6 @@ nvme_pci_attach(device_t dev)
 			4 * 1024 * 1024,		/* boundary */
 			BUS_SPACE_MAXADDR,		/* loaddr? */
 			BUS_SPACE_MAXADDR,		/* hiaddr */
-			NULL,				/* filter */
-			NULL,				/* filterarg */
 			sc->cmd_bytes,			/* [max]size */
 			1,				/* maxsegs */
 			sc->cmd_bytes,			/* maxsegsz */
@@ -375,8 +371,6 @@ nvme_pci_attach(device_t dev)
 			4 * 1024 * 1024,		/* boundary */
 			BUS_SPACE_MAXADDR,		/* loaddr? */
 			BUS_SPACE_MAXADDR,		/* hiaddr */
-			NULL,				/* filter */
-			NULL,				/* filterarg */
 			sc->res_bytes,			/* [max]size */
 			1,				/* maxsegs */
 			sc->res_bytes,			/* maxsegsz */
@@ -389,8 +383,6 @@ nvme_pci_attach(device_t dev)
 			4 * 1024 * 1024,		/* boundary */
 			BUS_SPACE_MAXADDR,		/* loaddr? */
 			BUS_SPACE_MAXADDR,		/* hiaddr */
-			NULL,				/* filter */
-			NULL,				/* filterarg */
 			sc->adm_bytes,			/* [max]size */
 			1,				/* maxsegs */
 			sc->adm_bytes,			/* maxsegsz */
diff --git a/sys/dev/disk/sbp/sbp.c b/sys/dev/disk/sbp/sbp.c
index 00637929b3..faf6a5cf43 100644
--- a/sys/dev/disk/sbp/sbp.c
+++ b/sys/dev/disk/sbp/sbp.c
@@ -1857,7 +1857,9 @@ END_DEBUG
 				/*boundary*/0,
 				/*lowaddr*/BUS_SPACE_MAXADDR_32BIT,
 				/*highaddr*/BUS_SPACE_MAXADDR,
+#if defined(__FreeBSD__)
 				/*filter*/NULL, /*filterarg*/NULL,
+#endif
 				/*maxsize*/0x100000, /*nsegments*/SBP_IND_MAX,
 				/*maxsegsz*/SBP_SEG_MAX,
 				/*flags*/BUS_DMA_ALLOCNOW,
diff --git a/sys/dev/disk/sdhci/sdhci.c b/sys/dev/disk/sdhci/sdhci.c
index 995703ccf6..22da5ffab8 100644
--- a/sys/dev/disk/sdhci/sdhci.c
+++ b/sys/dev/disk/sdhci/sdhci.c
@@ -547,7 +547,7 @@ sdhci_dma_alloc(struct sdhci_slot *slot)
 
 	/* Allocate DMA tag for 32bit ADMA2 data buffer */
 	err = bus_dma_tag_create(bus_get_dma_tag(slot->bus),
-	    4, 0, BUS_SPACE_MAXADDR_32BIT, BUS_SPACE_MAXADDR, NULL, NULL,
+	    4, 0, BUS_SPACE_MAXADDR_32BIT, BUS_SPACE_MAXADDR,
 	    MAXPHYS, SDHCI_ADMA2_DESC_COUNT,
 	    MIN(MAXPHYS, SDHCI_ADMA2_MAX_SEGSIZE),
 	    BUS_DMA_ALLOCNOW | BUS_DMA_ALLOCALL,
diff --git a/sys/dev/disk/sili/sili_attach.c b/sys/dev/disk/sili/sili_attach.c
index 8d533ee946..8d177fad7a 100644
--- a/sys/dev/disk/sili/sili_attach.c
+++ b/sys/dev/disk/sili/sili_attach.c
@@ -213,8 +213,6 @@ sili_pci_attach(device_t dev)
 			65536,				/* boundary */
 			addr,				/* loaddr? */
 			BUS_SPACE_MAXADDR,		/* hiaddr */
-			NULL,				/* filter */
-			NULL,				/* filterarg */
 			sizeof(struct sili_prb) * SILI_MAX_CMDS,
 							/* [max]size */
 			1,				/* maxsegs */
@@ -233,8 +231,6 @@ sili_pci_attach(device_t dev)
 			0,				/* boundary */
 			addr,				/* loaddr? */
 			BUS_SPACE_MAXADDR,		/* hiaddr */
-			NULL,				/* filter */
-			NULL,				/* filterarg */
 			4096 * 1024,			/* maxiosize */
 			SILI_MAX_SGET,			/* maxsegs */
 			65536,				/* maxsegsz */
diff --git a/sys/dev/disk/sym/sym_hipd.c b/sys/dev/disk/sym/sym_hipd.c
index e5a3a23bf1..e0f4207c7b 100644
--- a/sys/dev/disk/sym/sym_hipd.c
+++ b/sys/dev/disk/sym/sym_hipd.c
@@ -667,7 +667,7 @@ static m_pool_s *___cre_dma_pool(bus_dma_tag_t dev_dmat)
 		if (!bus_dma_tag_create(dev_dmat, 1, MEMO_CLUSTER_SIZE,
 			       BUS_SPACE_MAXADDR_32BIT,
 			       BUS_SPACE_MAXADDR,
-			       NULL, NULL, MEMO_CLUSTER_SIZE, 1,
+			       MEMO_CLUSTER_SIZE, 1,
 			       MEMO_CLUSTER_SIZE, 0,
 			       &mp->dmat)) {
 			mp->getp = ___dma_getp;
@@ -8578,7 +8578,6 @@ sym_pci_attach(device_t dev)
 	 */
 	if (bus_dma_tag_create(np->bus_dmat, 1, (1<<24),
 				BUS_SPACE_MAXADDR_32BIT, BUS_SPACE_MAXADDR,
-				NULL, NULL,
 				BUS_SPACE_MAXSIZE, SYM_CONF_MAX_SG,
 				(1<<24), 0,
 				&np->data_dmat)) {
diff --git a/sys/dev/disk/trm/trm.c b/sys/dev/disk/trm/trm.c
index 7c27bc74f8..73425d7cc3 100644
--- a/sys/dev/disk/trm/trm.c
+++ b/sys/dev/disk/trm/trm.c
@@ -3425,8 +3425,6 @@ trm_init(u_int16_t unit, device_t dev)
 	      /*boundary*/                       0,
 	      /*lowaddr*/  BUS_SPACE_MAXADDR,
 	      /*highaddr*/       BUS_SPACE_MAXADDR,
-	      /*filter*/                      NULL, 
-	      /*filterarg*/                   NULL,
 	      /*maxsize*/                 MAXBSIZE,
 	      /*nsegments*/               TRM_NSEG,
 	      /*maxsegsz*/    TRM_MAXTRANSFER_SIZE,
@@ -3440,8 +3438,6 @@ trm_init(u_int16_t unit, device_t dev)
 	/*boundary*/   0,
 	/*lowaddr*/    BUS_SPACE_MAXADDR,
 	/*highaddr*/   BUS_SPACE_MAXADDR,
-	/*filter*/     NULL,
-	/*filterarg*/  NULL,
 	/*maxsize*/    TRM_MAX_SRB_CNT * sizeof(TRM_SRB),
 	/*nsegments*/  1,
 	/*maxsegsz*/   TRM_MAXTRANSFER_SIZE,
@@ -3463,7 +3459,6 @@ trm_init(u_int16_t unit, device_t dev)
 	    /*boundary*/0,
 	    /*lowaddr*/BUS_SPACE_MAXADDR_32BIT,
 	    /*highaddr*/BUS_SPACE_MAXADDR,
-	    /*filter*/NULL, /*filterarg*/NULL,
 	    sizeof(struct scsi_sense_data) * TRM_MAX_SRB_CNT,
 	    /*nsegments*/1,
 	    /*maxsegsz*/TRM_MAXTRANSFER_SIZE,
@@ -3500,8 +3495,6 @@ trm_init(u_int16_t unit, device_t dev)
 		    /*boundary*/   0,
 		    /*lowaddr*/    BUS_SPACE_MAXADDR,
 		    /*highaddr*/   BUS_SPACE_MAXADDR,
-		    /*filter*/     NULL, 
-		    /*filterarg*/  NULL,
 		    /*maxsize*/    TRM_MAX_SG_LISTENTRY * sizeof(SGentry), 
 		    /*nsegments*/  1,
 		    /*maxsegsz*/   TRM_MAXTRANSFER_SIZE,
diff --git a/sys/dev/misc/dcons/dcons_crom.c b/sys/dev/misc/dcons/dcons_crom.c
index 5aa2006eac..651ade1804 100644
--- a/sys/dev/misc/dcons/dcons_crom.c
+++ b/sys/dev/misc/dcons/dcons_crom.c
@@ -174,7 +174,6 @@ dcons_crom_attach(device_t dev)
 		/*boundary*/ 0,
 		/*lowaddr*/ BUS_SPACE_MAXADDR,
 		/*highaddr*/ BUS_SPACE_MAXADDR,
-		/*filter*/NULL, /*filterarg*/NULL,
 		/*maxsize*/ dcons_conf->size,
 		/*nsegments*/ 1,
 		/*maxsegsz*/ BUS_SPACE_MAXSIZE_32BIT,
diff --git a/sys/dev/netif/ae/if_ae.c b/sys/dev/netif/ae/if_ae.c
index eb37fb6970..d3910da9b1 100644
--- a/sys/dev/netif/ae/if_ae.c
+++ b/sys/dev/netif/ae/if_ae.c
@@ -528,7 +528,6 @@ ae_dma_alloc(struct ae_softc *sc)
 	error = bus_dma_tag_create(NULL, 1, 0,
 				   BUS_SPACE_MAXADDR_32BIT,
 				   BUS_SPACE_MAXADDR,
-				   NULL, NULL,
 				   BUS_SPACE_MAXSIZE_32BIT,
 				   0,
 				   BUS_SPACE_MAXSIZE_32BIT,
